Portal_Proveedor/Models/Registro/CambioClave.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace Portal_Proveedor.Models.Registro
{
    public class CambioClave
    {
        public string usuario           {get;set;}
        public string claveVieja        {get;set;}
        public string claveNueva        {get;set;}
        public string confirmacionClave {get;set;}
    }
}

Portal_Proveedor/Models/Registro/EmailValidator.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Portal_Proveedor.Models.Registro
{
    public class EmailAttribute : RegularExpressionAttribute
    {
        public EmailAttribute() : base(@"^([\w\!\#$\%\&\'\*\+\-\/\=\?\^\`{\|\}\~]+\.)*[\w\!\#$\%\&\'\*\+\-\/\=\?\^\`{\|\}\~]+@((((([a-zA-Z0-9]{1}[a-zA-Z0-9\-]{0,62}[a-zA-Z0-9]{1})|[a-zA-Z])\.)+[a-zA-Z]{2,6})|(\d{1,3}\.){3}\d{1,3}(\:\d{1,5})?)$") { }
    }
}

Portal_Proveedor/Models/Registro/Registro.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace Portal_Proveedor.Models.Registro
{
    public class Registro
    {
        [Required]
        public string UserName { get; set; }

        //[Required]
        //public string nombre { get; set; }

        //[Required]
        //public string apellidos { get; set; }

        [Required]
        [Email(ErrorMessage = "Debe ingresar una dirección de correo electrónico válida")]
        public string correo { get; set; }

        [Required]
        public string clave { get; set; }

        [Required]
        public string confirmaClave { get; set; }

        [Required]
        public bool esExtranjero { get; set; }

        public string extranjero { get; set; }

       // [Required]
        public string RTN { get; set; }

        //[Required]
        public string nombreEmpresa { get; set; }
        public string pais { get; set; }
        public string correoSAP { get; set; }
        public bool activo { get; set; }
        public string msjError { get; set; }
        public int codeError { get; set; }
    }
}

Portal_Proveedor/Models/Registro/UsuariosIngresados.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace Portal_Proveedor.Models.Registro
{
    public class UsuariosIngresados
    {

        public int id { get; set; }
        public string usuario { get; set; }
        public DateTime fecha { get; set; }
    }
}

Portal_Proveedor/Controllers/RegistroController.cs
using Portal_Proveedor.Models.Correo;
using Portal_Proveedor.Models.Registro;
using Portal_Proveedor.Services.Utility;
using System;
using System.Web.Mvc;
using System.Web.Security;

namespace Portal_Proveedor.Controllers
{
    public class RegistroController : Controller
    {
        private RegistroDM rdm = new RegistroDM();

        [HttpGet]
        public ActionResult Registrarse()
        {
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Registrarse(Registro model)
        {
            ActionResult retorno = null;

            if (ModelState.IsValid)
            {
                try
                {
                    var Existe = Membership.GetUser(model.UserName);
                    if (Existe == null)
                    {
                        if (!rdm.ExisteRTN(model.RTN))
                        {
                            if (model.clave.Equals(model.confirmaClave))
                            {
                                model = rdm.ValidarProveedor(model);

                                model.activo = true;

                                if (model.activo)
                                {
                                    Membership.CreateUser(model.UserName, model.clave, model.correo);
                                    if (Membership.GetUser(model.UserName).ToString() != null)
                                    {
                                        MembershipUser user = Membership.GetUser(model.UserName);
                                        user.Comment = model.nombreEmpresa;
                                        Membership.UpdateUser(user);

                                        int res = rdm.RegistrarUsuario(model);
                                        if (res == 0)
                                        {
                                            Roles.AddUserToRole(model.UserName, "usuario");
                                            Membership.ValidateUser(model.UserName, model.clave);
                                            FormsAuthentication.SetAuthCookie(model.UserName, false);
                                            rdm.AgregarInicioSesion(model.UserName);
                                            //enviar correo
                                            CorreoElectronicoDM cedm = new CorreoElectronicoDM();
                                            cedm.EnviarCorreo(model.correo, "", 1);
                                            //retorno = RedirectToAction("Index", "Home");
                                            retorno = RedirectToAction("RegistroFacturas", "OnBase");

                                        }
                                        else
                                        {
                                            //Si falla
                                        }
                                    }
                                }
                                else
                                {
                                    switch (model.codeError)
                                    {
                                        case -1:
                                            ModelState.AddModelError("UserName", "El proveedor se encuentra bloqueado, por favor verifíquelos o comuníquese con el administrador.");
                                            break;
                                        case -2:
                                            ModelState.AddModelError("UserName", "El proveedor no existe en el sistema, por favor verifíquelos o comuníquese con el administrador.");
                                            break;
                                        default:
                                            ModelState.AddModelError("UserName", "Los datos del proveedor no coinciden, por favor verifíquelos o comuníquese con el administrador.");
                                            break;
                                    }

                                    retorno = View("Registrarse", model);
                                }

                            }
                            else
                            {
                                ModelState.AddModelError("UserName", "Las claves no coinciden, por favor ingréselas de nuevo.");
                                retorno = View("Registrarse", model);
                            }
                        }
                        else
                        {
                            ModelState.AddModelError("UserName", "El RTN indicado ya se encuentra registrado, verifique la información ingresada.");
                            retorno = View("Registrarse", model);
                        }
                    }
                    else
                    {
                        ModelState.AddModelError("UserName", "El proveedor ya se encuentra registrado, para ingresar debe iniciar sesión.");
                        retorno = View("Registrarse", model);
                    }
                }
                catch (Exception ex)
                {
                    ModelState.AddModelError("UserName", "Ha ocurrido un error inesperado, por favor comuníquese con el administrador. " + ex.Message);
                    retorno = View("Registrarse", model);
                    LoggerManager.GetInatance().Error($"Failed method Registrarse in RegistroContoller, System message: {ex}");
                }
            }
            else
            {
                ModelState.AddModelError("UserName", "Debe ingresar todos los datos para proceder .");
                retorno = View("Registrarse", model);
            }

            return retorno;
        }

        [HttpGet]
        public ActionResult InicioSesion()
        {
            if (User.Identity.Name != null && User.Identity.Name !="")
            {
                if (Roles.IsUserInRole(User.Identity.Name, "admin"))
                {
                    return RedirectToAction("ReporteInicioSesion", "Administracion");
                }
                else
                {
                    return RedirectToAction("RegistroFacturas", "OnBase");
                }
            }

            return View();
        }

        [HttpPost]
        public ActionResult InicioSesion(Registro model)
        {
            ActionResult retorno = null;
            string resultado = null;

            try
            {
                if (model.UserName != null)
                {
                    var Existe = Membership.GetUser(model.UserName);
                    if (Existe != null)
                    {
                        if (model.clave != null)
                        {
                            MembershipUser user = Membership.GetUser(model.UserName);
                            //if (!rdm.RequiereCambioClave(model.UserName))
                            //{
                            if (model.UserName == "admin" && Membership.ValidateUser(model.UserName, model.clave))
                            {
                                if (user.IsLockedOut)
                                    user.UnlockUser();
                                FormsAuthentication.SetAuthCookie(model.UserName, false);
                                rdm.AgregarInicioSesion(model.UserName);
                                if (HttpContext.Session["returl"] as String != null && Url.IsLocalUrl(HttpContext.Session["returl"] as String))
                                {
                                    return Redirect(HttpContext.Session["returl"] as String);
                                }
                                //retorno = RedirectToAction("Index", "Home");
                                if (Roles.IsUserInRole(user.UserName, "admin"))
                                {
                                    retorno = RedirectToAction("ReporteInicioSesion", "Administracion");
                                }
                                else
                                {
                                    retorno = RedirectToAction("RegistroFacturas", "OnBase");
                                }
                            }
                            else if (rdm.ProveedorBloqueado(model))//!user.IsApproved)
                            {
                                if (!user.IsLockedOut)
                                    for (int i = 0; i < Membership.MaxInvalidPasswordAttempts; i++)
                                        Membership.ValidateUser(user.UserName, "passwordError");
                                resultado = "En este momento no se puede ingresar con el usuario indicado porque se encuentra bloqueado, por favor comuníquese con el administrador del sistema";
                                ModelState.AddModelError("UserName", resultado);
                                retorno = View("InicioSesion", model);
                            }
                            else if (Membership.ValidateUser(model.UserName, model.clave))
                            {
                                if (user.IsLockedOut)
                                    user.UnlockUser();
                                FormsAuthentication.SetAuthCookie(model.UserName, false);
                                rdm.AgregarInicioSesion(model.UserName);
                                if (HttpContext.Session["returl"] as String != null && Url.IsLocalUrl(HttpContext.Session["returl"] as String))
                                {
                                    return Redirect(HttpContext.Session["returl"] as String);
                                }
                                //retorno = RedirectToAction("Index", "Home");
                                if (Roles.IsUserInRole(user.UserName, "admin"))
                                {
                                    retorno = RedirectToAction("ReporteInicioSesion", "Administracion");

Portal_Proveedor/Views/Registro/InicioSesion.cshtml
@model Portal_Proveedor.Models.Registro.Registro
@{
    ViewData["Title"] = "InicioSesion";
    Layout = "~/Views/Shared/_Layout.cshtml";
}


<br />
<div class="cotainer">
    @using (Html.BeginForm("InicioSesion", "Registro", FormMethod.Post, new { @class = "form-horizontal" }))
    {
    <fieldset>
        <!-- Form Name -->

        <div class="card-header">
            <legend>Inicio de Sesi&oacute;n</legend>
            <div style="float: right; font-size: 80%; position: relative; top: -10px;">
                @Html.ActionLink("¿Olvidó su clave?", "OlvidoClave", "Registro")
            </div>
        </div>

        @*<div class="form-group">
            
            <div class="col-md-12" style="text-align:center;">
                <img src="~/Content/images/cenosa001.png" />
             
            </div>
        </div>*@

        <!-- Text input-->
        <div class="form-group">
            <label class="col-md-4 control-label" for="email">Usuario</label>
            <div class="col-md-4">
                @Html.TextBoxFor(m => m.UserName, null, new { id = "usuario", name = "usuario", type = "text", placeholder = "Usuario", @class = "form-control input-md", required = "" })


            </div>
        </div>
        <!-- Password input-->
        <div class="form-group">
            <label class="col-md-4 control-label" for="password">Contrase&ntilde;a</label>
            <div class="col-md-4">
                @Html.TextBoxFor(m => m.clave, null, new { id = "password", name = "password", type = "password", placeholder = "Clave", @class = "form-control input-md", required = "" })

            </div>
        </div>

        <div class="form-group">
            <div class="col-md-10" style="text-align:center;">
                @Html.ValidationMessageFor(m => m.UserName, "", new { @class = "text-danger" })
            </div>
        </div>

        <!-- Button (Double) -->
        <div class="form-group">
            <label class="col-md-4 control-label" for="save"></label>
            <div class="col-md-8">
                <button id="save" name="save" class="btn btn-success">Iniciar</button>
                <button id="clear" name="clear" class="btn btn-danger">Cancelar</button>
            </div>
        </div>

        <div class="form-group">
            <div class="col-lg-12 control">
                <div class="col-md-12" style="padding-top: 15px; font-size: 85%;">
                    No tienes una cuenta!
                    @Html.ActionLink("Crea una aquí", "Registrarse", "Registro")
                </div>
            </div>
        </div>
    </fieldset>

    }
</div>

Portal_Proveedor/Views/Registro/OlvidoClave.cshtml
@model Portal_Proveedor.Models.Registro.Registro
@{
    ViewBag.Title = "OlvidoClave";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<br />
<div class="cotainer">
    <form class="form-horizontal">
        @Html.AntiForgeryToken()
        <fieldset>
            <!-- Form Name -->

            <div class="card-header">
                <legend>Olvid&oacute; su clave</legend>

            </div>
            <!-- Text input-->
            <div class="form-group">
                <label class="col-md-4 control-label" for="email">Usuario</label>
                <div class="col-md-4">
                    @Html.TextBoxFor(m => m.UserName, null, new { id = "usuario", name = "usuario", type = "text", placeholder = "Usuario", @class = "form-control input-md", required = "" })


                </div>
            </div>
            <!-- Password input-->
            <div class="form-group">
                <label class="col-md-4 control-label" for="password">Correo electr&oacute;nico</label>
                <div class="col-md-4">
                    @Html.TextBoxFor(m => m.correo, null, new { id = "correo", name = "correo", type = "text", placeholder = "correo@ejemplo.com", @class = "form-control input-md", required = "" })

                </div>
            </div>



            <!-- Button (Double) -->
            <div class="form-group">
                <label class="col-md-4 control-label" for="save"></label>
                <div class="col-md-8">
                    <a id="save" name="save" class="btn btn-warning" onclick="CambioClave()">Enviar</a>
                </div>
            </div>
            <br />
            <br />
            <div class="form-group">
                <p class="col-md-8">
                    Una vez validemos la información, la clave se estar&aacute; enviando a su correo electr&oacute;nico.

                </p>
            </div>
            <br />
            <br />

        </fieldset>

    </form>
</div>

<script type="text/javascript">

    $(document).ready(function () {

    });

    var CambioClave = function () {
        $.ajax({
            type: "POST",
            async: false,
            url: '@Url.Action("RegenerarClave", "Registro")',
            data: {
                UserName: $("#usuario").val(),
                correo: $("#correo").val()
            },
            success: function (data) {
                if (data === "Se ha enviado un correo con las indicaciones para cambiar la clave.") {
                    //Alerta("success", "Se ha enviado un correo con las indicaciones para cambiar la clave.", 'top');
                    alert("Se ha enviado un correo con las indicaciones para cambiar la clave.");
                    $("#usuario").val("");
                    $("#correo").val("");
                }
                else {
                    //Alerta("error", "Ha ocurrido un error, por favor verifique los datos e inténtelo de nuevo.", 'top');
                    alert("Ha ocurrido un error, por favor verifique los datos e inténtelo de nuevo.");
                }
            }
        });
    };

</script>

Portal_Proveedor/Views/Registro/RecuperarClave.cshtml
@model Portal_Proveedor.Models.Registro.CambioClave
@{
    ViewBag.Title = "RecuperarClave";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Recuperar la Clave</h2>

<br />

<form class="form-horizontal">
    @Html.AntiForgeryToken()
    @Html.HiddenFor(m => m.usuario, new { @id = "usuario" })
    <div class="form-group">

        <div class="row">
            <div class="col-md-3"></div>
            <div class="col-md-3">
                <label class="control-label" for="fname">Clave de recuperaci&oacute;n:</label>
            </div>
            <div class="col-md-3">
                @Html.TextBoxFor(m => m.claveVieja, new { @class = "form-control input-md", @id = "claveCambia", @name = "claveCambia", type = "password" })
            </div>
            <div class="col-md-3"></div>
        </div>
        <br />
        <div class="row">
            <div class="col-md-3"></div>
            <div class="col-md-3">
                <label class="control-label" for="fname">Clave nueva:</label>
            </div>
            <div class="col-md-3">
                @Html.TextBoxFor(m => m.claveNueva, new { @class = "form-control input-md", @id = "claveNueva", @name = "claveNueva", @type = "password" })
            </div>
            <div class="col-md-3"></div>
        </div>
        <br />
        <div class="row">
            <div class="col-md-3"></div>
            <div class="col-md-3">
                <label class="control-label" for="fname">Confirmaci&oacute;n de la clave nueva:</label>
            </div>
            <div class="col-md-3">
                @Html.TextBoxFor(m => m.confirmacionClave, new { @class = "form-control input-md", @id = "claveNuevaConf", @name = "claveNuevaConf", type = "password" })

            </div>
            <div class="col-md-3"></div>
        </div>
        <br />
        <div class="row">
            <div class="col-md-3"></div>
            <div class="col-md-3">

            </div>
            <div class="col-md-3">
                <a id="save" name="save" class="btn btn-success" onclick="CambioClave()">Guardar</a>
                &nbsp; &nbsp;
                <button id="clear" name="clear" class="btn btn-danger">Cancelar</button>

            </div>
            <div class="col-md-3"></div>
        </div>
        <br />
    </div>
</form>


<script type="text/javascript">

    var CambioClave = function () {
        $.ajax({
            type: "POST",
            async: false,
            url: '@Url.Action("RecuperacionClave", "Registro")',
            data: {
                usuario: $("#usuario").val(),
                claveVieja: $("#claveCambia").val(),
                claveNueva: $("#claveNueva").val(),
                confirmacionClave: $("#claveNuevaConf").val()
            },
            success: function (data) {
                if (data=== "Se ha cambiado la clave exitosamente.") {
                    alert(data);
                    // Alerta("success", data, 'top');

                    window.location.href = '@Url.Content("~/Home/Index/")';
                }
                else {
                    alert( data);
                   //Alerta("error", data, 'top');
                }
            }
        });
    };

</script>

Portal_Proveedor/Views/Registro/Registrarse.cshtml
@model Portal_Proveedor.Models.Registro.Registro
@{
    ViewData["Title"] = "Registrarse";
    Layout = "~/Views/Shared/_Layout.cshtml";

    <script src="@Url.Content("~/Scripts/jquery.mask.js")"></script>
}

<br />
<div class="cotainer">
    @using (Html.BeginForm("Registrarse", "Registro", FormMethod.Post, new { @class = "form-horizontal" }))
    {
        @Html.AntiForgeryToken()
        <fieldset>
            <!-- Form Name -->
            <legend>Reg&iacute;strese</legend>
            <div class="form-group">
                <label class="col-md-4 control-label" for="fname">Usuario</label>
                <div class="col-md-4">
                    @Html.TextBoxFor(m => m.UserName, null, new { id = "usuario", name = "usuario", placeholder = "Código proveedor SAP", @class = "form-control input-md", required = "" })

                </div>
            </div>

            <!-- Text input-->
            <div class="form-group">
                <label class="col-md-4 control-label" for="email">Correo electr&oacute;nico</label>
                <div class="col-md-4">
                    @Html.TextBoxFor(m => m.correo, null, new { id = "email", name = "email", placeholder = "correo@ejemplo.com", @class = "form-control input-md", required = "" })
                    @Html.ValidationMessageFor(m => m.correo, null, new { @class = "text-danger" })
                </div>
            </div>

            <!-- Text input-->
            <div class="form-group">
                <label class="col-md-4 control-label" for="fname">Es extranjero</label>
                <div class="col-md-4">
                    @Html.CheckBoxFor(m => m.esExtranjero, new { @id = "esExtranjero", @class = "" })

                </div>
            </div>
            <!-- Text input-->
            <div class="form-group" id="rucDiv">
                <label class="col-md-4 control-label" for="lname">RTN</label>
                <div class="col-md-4">
                    @Html.TextBoxFor(m => m.RTN, null, new { id = "ruc", name = "ruc", placeholder = "RTN", @class = "form-control input-md" })

                </div>
            </div>
            <!-- Password input-->
            <div class="form-group">
                <label class="col-md-4 control-label" for="password">Contrase&ntilde;a</label>
                <div class="col-md-4">
                    @Html.TextBoxFor(m => m.clave, null, new { id = "password", name = "password", type = "password", placeholder = "", @class = "form-control input-md", required = "" })
                </div>
            </div>
            <div class="form-group">
                <label class="col-md-4 control-label" for="password">Confirmar contrase&ntilde;a</label>
                <div class="col-md-4">
                    @Html.TextBoxFor(m => m.confirmaClave, null, new { id = "password2", name = "password2", type = "password", placeholder = "", @class = "form-control input-md", required = "" })
                </div>
            </div>
            <!-- Button (Double) -->

            <div class="form-group">
                <div class="col-md-10" style="text-align:center;">
                    @Html.ValidationMessageFor(m => m.UserName, "", new { @class = "text-danger" })
                </div>
            </div>

            <div class="form-group">
                <label class="col-md-4 control-label" for="save"></label>
                <div class="col-md-8">
                    <button id="save" name="save" class="btn btn-success">Registrarse</button>
                    <button id="clear" name="clear" class="btn btn-danger">Cancelar</button>
                </div>
            </div>
        </fieldset>
    }
</div>

<script>
    $(function () {
        $('#ruc').mask('00000000000000')
    });

    $('#esExtranjero').click(function () {

        if ($('#esExtranjero').is(':checked')) {
            $("#rucDiv").hide();
        } else {
            $("#rucDiv").show();
        }
    });


</script>